unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button2: TButton;
    Image1: TImage;
    Timer1: TTimer;
    Button3: TButton;
    LabelResult: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button4: TButton;
    Label7: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer1Timer2(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
   a,b : integer;
   rect : TRect;

   
implementation

uses Unit2,common, Unit3;

{$R *.xfm}

procedure TForm1.Button2Click(Sender: TObject);
begin
   Button2.Enabled:=false;
   a:=trunc(image1.Height/2);
   b:=trunc(image1.Width/2);
   rect.Left:=0;
   rect.Top:=0;
   rect.Right:=a*2;
   rect.Bottom:=b*2;

   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clblack;
   end;

   image1.canvas.FillRect(rect);

   with image1.canvas.Brush do
   begin
     Style:=bsSolid;
     Color:=clwhite;
   end;
   image1.Canvas.Ellipse(a,b,a+5,b+5);

   with timer1 do
   begin
     Interval:=random(occ_rapidite);
     OnTimer:=Timer1Timer;
     { on lance le timer de visibilit initiale : }
     enabled:=true;
   end;
end;

procedure TForm1.Timer1Timer2(Sender: TObject);
var
   s : string;
   ecart : real;
begin
{ Cette procdure est appele  la fin de l'occultation }
   timer1.Enabled:=false;
   occ_fin:=Gettime;
   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clBlack;
   end;
   image1.canvas.FillRect(rect);
   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clwhite;
   end;
   Image1.Canvas.Ellipse(a,b,a+5,b+5);
   With timer1 do
   begin
      OnTimer:=Timer1Timer;
      Enabled:=false;
   end;
   Button2.Enabled:=true;
   ecart:=((occ_fin-occ_debut)*86400);
   Str(ecart:5:2,s);
   LabelResult.Caption:=s;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
{ Cette procdure est appele au dbut de l'occultation }
   timer1.Enabled:=false;
   occ_debut:=Gettime;

   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clblack;
   end;          {On efface l'toile }
   image1.canvas.FillRect(rect);
   with timer1 do
   begin
      OnTimer:=Timer1Timer2;
      Interval:=random(occ_rapidite);
      Enabled:=true;
   end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   Form2.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   occ_rapidite:=5000;

   with image1.canvas.Brush do
   begin
      Style:=bsSolid;
      Color:=clblack;
   end;

   image1.canvas.FillRect(rect);

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   Form3.show;
end;

end.
